#################################################
# Distribution Dymanics for GDP per worker EU27 #
#################################################

rm(list=ls(all=TRUE))
graphics.off()

library(foreach)
library(doMC)
library(base)
registerDoMC(1)

#Load dataset
load("datasetNUTS2_CE2010_EU27_forGRV_analysis")


#Define variable
  GDPpw <- samplePerWorkerGDP_27
  
  GDPpwRel <- samplePerWorkerGDPRel_27
  colnames(GDPpwRel) <- c(1991:2008)
  
  GDPpwGR <- samplePerWorkerGDPGR_27

  numYears <- ncol(GDPpw)

  #Firtst and last year of the sample
  PROD.InitialYear.REL <- (GDPpwRel[,1])
  
  PROD.FinalYear.REL <-  (GDPpwRel[,(numYears)])

    #=========================================================#
    # Density distributions for GDP PER WORKER relative terms #
    #=========================================================#
     
    #Estimate and plot the histogram 
    estimateDensityInitialYear_hist <- hist(PROD.InitialYear.REL) 
     
    #Estimate and plot the kernel density using "sm" function
    library(sm)
    estimateDensityInitialYear_sm <- sm.density(PROD.InitialYear.REL)
	
	sm.density(PROD.InitialYear.REL, model="normal")


    #Estimate and plot the kernel density using "univariate" function
	#------------------------------------------------------#	
	# Estimation of univariate density via Adaptive Kernel #
	source("univariateDensityAdaptive_Parallel.r")
	#--------------------------------------------------------------#
	# Calculation of the weighted standard deviation of a variable #
	source("weighted.sd.r")

    estimateDensityInitialYear_univ <- univariateDensityAdaptive_Parallel(PROD.InitialYear.REL, figure=TRUE)



	#Bootstrap for confidence bands	
    B <-100
    for (b in 1:B){
    	PROD.InitialYear.REL_boot <- sample(PROD.InitialYear.REL, replace=TRUE)
    	sm.density(PROD.InitialYear.REL_boot, add=TRUE)
    }

    estimateDensityInitialYear_sm <- sm.density(PROD.InitialYear.REL, col="red", add=T)
    


